import cv2

cap = cv2.VideoCapture('../ARC07881.MOV')
#cap = cv2.VideoCapture('../output.mov')

# Parameters for Shi-Tomasi corner detection
feature_params = dict( maxCorners = 300,
                       qualityLevel = 0.2,
                       minDistance = 7,
                       blockSize = 7 )

# Parameters for LK tracker
lk_params = dict( winSize  = (10,10),
                  maxLevel = 3,
                  criteria = (cv2.TERM_CRITERIA_EPS\
                              | cv2.TERM_CRITERIA_COUNT, 10, 0.03))

p0 = None
while 1:
    ret, frame = cap.read()
    frame = cv2.resize(frame, (720, 420))
    frame_gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)

    if p0 != None:
        p1, st, err = cv2.calcOpticalFlowPyrLK(old_gray, frame_gray,\
                                               p0, None, **lk_params)
        # Draw the flows
        for i in range(len(p0)):
            if st[i] == 1:
                a, b = p1[i,0,0], p1[i,0,1] #p1[i][0][0], p1[i][0][1]
                c, d = p0[i][0][0], p0[i][0][1]
                cv2.line(frame, (a,b), (c,d), (255,0,255), 2)
                cv2.circle(frame, (a,b), 5, (255,0,255), -1)

    cv2.imshow('frame', frame)
    if cv2.waitKey(300) & 0xff == 0x1b: # ESC
        break

    # Find good feature points to track
    old_gray = frame_gray.copy()
    p0 = cv2.goodFeaturesToTrack(old_gray, mask = None, **feature_params)

cv2.destroyAllWindows()
cap.release()
