import numpy as np
import cv2

cap = cv2.VideoCapture(0) # 0,1,... Choose your camera
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_WIDTH, 640)
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT, 480)

# Initialization
x0, y0, w, h = 320-50, 240-50, 100, 100
track_window = (x0, y0, w, h)
roi_hist = None

# Termination criteria = 10 iteration or 1 pix motion
term_crit = ( cv2.TERM_CRITERIA_EPS | cv2.TERM_CRITERIA_COUNT, 10, 1 )

while 1:
    ret, frame = cap.read()

    if roi_hist != None:
        hsv = cv2.cvtColor(frame, cv2.COLOR_BGR2HSV)
        dst = cv2.calcBackProject([hsv], [0], roi_hist, [0,180], 1)
        ret, track_window = cv2.meanShift(dst, track_window, term_crit)

    x, y, w, h = track_window
    cv2.rectangle(frame, (x, y), (x+w, y+h), 255, 2)
    cv2.imshow('Meanshift tracker', frame)

    k = cv2.waitKey(5)
    if k == 0x20: # Space bar
        # Create histogram for the target
        hsv_roi =  cv2.cvtColor(frame[y:y+h,x:x+w], cv2.COLOR_BGR2HSV)
        roi_hist = cv2.calcHist([hsv_roi], [0], None, [32], [0,180]) 
        cv2.normalize(roi_hist, roi_hist, 0, 255, cv2.NORM_MINMAX)
        print roi_hist
    elif k == 0x1b: # ESC
        break

cv2.destroyAllWindows()
cap.release()
