import numpy as np
import cv2

cap = cv2.VideoCapture(0) # 0,1,... Choose your camera
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_WIDTH, 640)
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT, 480)

# Initialization
x, y, w, h = 320-50, 240-50, 100, 100
templ = None

# Termination criteria = 10 iteration or 1 pix motion
term_crit = ( cv2.TERM_CRITERIA_EPS | cv2.TERM_CRITERIA_COUNT, 10, 1 )

while 1:
    ret, frame = cap.read()
    frame_gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)

    if templ != None:
        resp = cv2.matchTemplate(frame_gray, templ, method=cv2.TM_SQDIFF)
        min, max, minpos, maxpos = cv2.minMaxLoc(resp)
        x, y = minpos[0], minpos[1]

    cv2.rectangle(frame, (x, y), (x+w, y+h), 255, 2)
    cv2.imshow('Template tracker', frame)

    k = cv2.waitKey(5)
    if k == 0x20: # Space bar
        # Capture the target
        templ = frame_gray[y:y+h, x:x+w].copy()
    elif k == 0x1b: # ESC
        break

cv2.destroyAllWindows()
cap.release()
